<?php
/**
 * Plugin Name: Market Scan News Widget
 * Plugin URI:
 * Description: A widget that serves as an Market Scan News for developing more advanced widgets.
 * Version: 0.1
 * Author: Netleon
 * Author URI: netleon.com
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */

/**
 * Add function to widgets_init that'll load our widget.
 * @since 0.1
 */
add_action( 'widgets_init', 'market_scan_news_widgets' );

/**
 * Register our widget.
 * 'market_scan_news_widgets' is the widget class used below.
 *
 * @since 0.1
 */
function market_scan_news_widgets() {
	register_widget( 'Market_Scan_News' );
}

/**
 * Market Scan News Widget class.
 * This class handles everything that needs to be handled with the widget:
 * the settings, form, display, and update.  Nice!
 *
 * @since 0.1
 */
class Market_Scan_News extends WP_Widget {

	/**
	 * Widget setup.
	 */
	function Market_Scan_News() {
		/* Widget settings. */
		$widget_ops = array( 'classname' => 'Market Scan News', 'description' => __('An Market Scan News widget that displays market news ', 'Market Scan News') );

		/* Widget control settings. */
		$control_ops = array( 'width' => 300, 'height' => 350, 'id_base' => 'market-scan-news-widget' );

		/* Create the widget. */
		$this->WP_Widget( 'market-scan-news-widget', __('Market Scan News Widget', 'Market Scan News'), $widget_ops, $control_ops );
	}

	/**
	 * How to display the widget on the screen.
	 */
	function widget( $args, $instance ) {
		extract( $args );

		/* Our variables from the widget settings. */
		$param1 = apply_filters('widget_title', $instance['param1'] );
		$rows = $instance['rows'];
		/* Before widget (defined by themes). */
		
			 
		
		if(isset($instance)){
         	echo $before_title; 	
			
			$formObj = new formSymbol();
    		$formObj-> commonForm(); 
			
			echo $after_title;
			if(isset($_REQUEST['symbol'])){
				$param1=$_REQUEST['symbol'];
				$rows = $instance['rows'];
			}
			market_scan_wp_related_news($param1,$rows);
		}
		
		
	}

	/**
	 * Update the widget settings.
	 */
	function update( $new_instance, $old_instance ) {
		
		$instance = $old_instance;

		/* Strip tags for title and name to remove HTML (important for text inputs). */
		$instance['param1'] =  $new_instance['param1'] ;
		$instance['rows']   =  $new_instance['rows']  ;
			
		return $instance;
	}

	/**
	 * Displays the widget settings controls on the widget panel.
	 * Make use of the get_field_id() and get_field_name() function
	 * when creating your form elements. This handles the confusing stuff.
	 */
	function form( $instance ) {

		/* Set up some default widget settings. */
		$defaults = array( 'param1' => __('goog', 'Market Scan News'));
		
		$instance = wp_parse_args( (array) $instance, $defaults ); ?>

		<!-- Widget Title: Text Input -->
		<p>
			<label for="<?php echo $this->get_field_id( 'param1' ); ?>"><?php _e('symbol:', 'hybrid'); ?></label>
			<input id="<?php echo $this->get_field_id( 'param1' ); ?>" name="<?php echo $this->get_field_name( 'param1' ); ?>" value="<?php echo $instance['param1']; ?>" style="width:50%;" />
		</p>
        
        <p>
			<label for="<?php echo $this->get_field_id( 'rows' ); ?>"><?php _e('Rows:', 'hybrid'); ?></label>&nbsp;&nbsp;&nbsp;
			<input id="<?php echo $this->get_field_id( 'rows' ); ?>" name="<?php echo $this->get_field_name( 'rows' ); ?>" value="<?php echo $instance['rows']; ?>" style="width:50%;" />
		</p>


	<?php
	}
}

?>