<?php

//require (WP_PLUGIN_DIR.'/market-scan/includes/get-info.php');

class Symbol
{
	const Symbol 				= 0;
	const CompanyName 			= 1;
	const LastTrade 			= 2;
	const TradeTime 			= 3;
	const Change_PercentChange	= 4; 
	const Open					= 5;
	const PreviousClose			= 6;
	const Bid					= 7;
	const Ask					= 8;
	const DaysRange				= 9;
	const WeekRange52			= 10;
	const Volume				= 11;
	const AvgVolume				= 12;
	const MarketCap				= 13;
	const PE					= 14;
	const EPS					= 15;
	const Change			 	= 16;
	const PercentChange			= 17;
	// Below are custom made (not obtained from Yahoo)
	const BidPercentChangeLastTrade	= 18;
	const BidPercentChangePreviousClose	= 19;
	const BidPercentChangeOpen	= 20;
	const BidChangeLastTrade	= 21;
	const BidChangePreviousClose	= 22;
	const BidChangeOpen			= 23;
	const AskPercentChangeLastTrade	= 24;
	const AskPercentChangePreviousClose	= 25;
	const AskPercentChangeOpen	= 26;
	const AskChangeLastTrade	= 27;
	const AskChangePreviousClose	= 28;
	const AskChangeOpen			= 29;
	const LastTradePercentChangeOpen	= 30;
	const LastTradeChangeOpen	= 31;
}

function symbolInformation($symbol = null, $query = null, $preloadedSymbols = null) {
	static $symbols = array();
	if(null != $preloadedSymbols) {
		$symbols = array_merge($symbols, $preloadedSymbols);
		return;
	}
	if(!$symbol) {
		return $symbol;
	}
	
	//$symbol = strToUpper(getFullSymbol($symbol));
	$symbol = strToUpper($symbol);
	
	if(!isset($symbols[$symbol])) {
	/*	$url = 'http://finance.yahoo.com/d/quotes.csv?s='.$symbol.'&f=snl1t1copbamwva2j1rec1p2&e=.csv';
		$fp = fopen($url, 'r');
		$data = fgetcsv ($fp, 1000, ',');
		fclose($fp);
		$symbols[$symbol] = $data;
	*/
	$symbols = array_merge($symbols, queryYahooFinance(array($symbol))); 
	}
	
	if($query || $query === Symbol::Symbol) {
		return $symbols[$symbol][$query];
	}
	
	return $symbols[$symbol];
}

function preloadSymbols(array $symbols = array()) {
	if(empty($symbols)) {
		return;
	}
	$preloadedSymbols = queryYahooFinance($symbols);
	symbolInformation(null,null,$preloadedSymbols);
	return;
}

function queryYahooFinance(array $symbols = array())
{
	if(empty($symbols)) {
		return $symbols;
	}

	$symbolList = '';
	$data = array();
	foreach($symbols as $value) {
		$symbolList .= $value . '+'; 
	}

	$url = 'http://download.finance.yahoo.com/d/quotes.csv?s='.$symbolList.'&f=snl1t1copbamwva2j1rec1p2&e=.csv';
	//$fp = fopen($url, 'r');
	
	if (($fp = fopen($url, "r")) !== FALSE) {
	while(($tmpData = fgetcsv($fp)) !== false) {
		
		$key = $tmpData[0];
		$data[$key] = $tmpData;
	}
	}
	fclose($fp);
	
	return $data;
}

function symbolFullSymbol($symbol = null) {
	return SymbolInformation($symbol, Symbol::Symbol);
}

function fs($symbol = null) {
	return symbolFullSymbol($symbol);
}

function symbolCompanyName($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::CompanyName);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'CompanyName');
	}
	return $returnString;
}

function symbolLastTrade($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::LastTrade);
	$returnString = isUpDown(symbolInformation($symbol, Symbol::Change), $returnString);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="LastTrade">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolTradeTime($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::TradeTime);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="TradeTime">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolChange_PercentChange($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Change_PercentChange);
	$returnString = isUpDown(symbolInformation($symbol, Symbol::Change), $returnString);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Change_percentChange">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolOpen($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Open);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Open">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolPreviousClose($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::PreviousClose);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="PreviousClose">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolBid($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Bid);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Bid">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolAsk($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Ask);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Ask">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolDaysRange($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::DaysRange);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="DaysRange">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolWeekRange52($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::WeekRange52);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="WeekRange52">'.$returnString.'</span>';
	}
	return $returnString;
}


function symbolVolume($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Volume);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Volume">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolAvgVolume($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::AvgVolume);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="AvgVolume">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolMarketCap($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::MarketCap);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="MarketCap">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolPE($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::PE);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="PE">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolEPS($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::EPS);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="EPS">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolPercentChange($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::PercentChange);
	$returnString = isUpDown(symbolInformation($symbol, Symbol::Change), $returnString);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="PercentChange">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolChange($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::Change);
	$returnString = isUpDown(symbolInformation($symbol, Symbol::Change), $returnString);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="Change">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolBidPercentChangeLastTrade($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$returnString = isUpDown((($bid - $lastTrade) / $lastTrade) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidPercentChangeLastTrade');
	}
	return $returnString;
}

function symbolBidPercentChangePreviousClose($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$previousClose = symbolInformation($symbol, Symbol::PreviousClose);
	$returnString = isUpDown((($bid - $previousClose)/$previousClose) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidPercentChangePreviousClose');
	}
	return $returnString;
}

function symbolBidPercentChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown((($bid - $open) / $open) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidPercentChangeOpen');
	}
	return $returnString;
}

function symbolBidChangeLastTrade($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$returnString = isUpDown($bid - $lastTrade);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidChangeLastTrade');
	}
	return $returnString;
}

function symbolBidChangePreviousClose($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$previousClose = symbolInformation($symbol, Symbol::PreviousClose);
	$returnString = isUpDown($bid - $previousClose);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidChangePreviousClose');
	}
	return $returnString;
}

function symbolBidChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$bid = symbolInformation($symbol, Symbol::Bid);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown($bid - $open);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'BidChangeOpen');
	}
	return $returnString;
}

function symbolAskPercentChangeLastTrade($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$returnString = isUpDown((($ask - $lastTrade) / $lastTrade) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskPercentChangeLastTrade');
	}
	return $returnString;
}

function symbolAskPercentChangePreviousClose($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$previousClose = symbolInformation($symbol, Symbol::PreviousClose);
	$returnString = isUpDown((($ask - $previousClose)/$previousClose) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskPercentChangePreviousClose');
	}
	return $returnString;
}

function symbolAskPercentChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown((($ask - $open) / $open) * 100);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskPercentChangeOpen');
	}
	return $returnString;
}

function symbolAskChangeLastTrade($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$returnString = isUpDown($ask - $lastTrade);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskChangeLastTrade');
	}
	return $returnString;
}

function symbolAskChangePreviousClose($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$previousClose = symbolInformation($symbol, Symbol::PreviousClose);
	$returnString = isUpDown($ask - $previousClose);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskChangePreviousClose');
	}
	return $returnString;
}

function symbolAskChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$ask = symbolInformation($symbol, Symbol::Ask);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown($ask - $open);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'AskChangeOpen');
	}
	return $returnString;
}

function symbolLastTradePercentChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown(($lastTrade - $open) / $open);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'LastTradePercentChangeOpen');
	}
	return $returnString;
}

function symbolLastTradeChangeOpen($symbol = null, $jsAutoUpdate = false) {
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$open = symbolInformation($symbol, Symbol::Open);
	$returnString = isUpDown($lastTrade - $open);
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'LastTradeChangeOpen');
	}
	return $returnString;
}

function symbolDayHigh($symbol = null, $jsAutoUpdate = false)  {
	list($low, $high) = explode(' - ', symbolInformation($symbol, Symbol::DaysRange));
	$returnString = $high;
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'DayHigh');
	}
	return $returnString;
}

function symbolDayLow($symbol = null, $jsAutoUpdate = false)  {
	list($low, $high) = explode(' - ', symbolInformation($symbol, Symbol::DaysRange));
	$returnString = $low;
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'DayLow');
	}
	return $returnString;
}

function setBarWidth($width = null) {
	static $barWidth = 0;
	if($width) {
		$barWidth = $width;
		$return;
	}
	return $barWidth;
}

function getBarWidth() {
	return setBarWidth();
}

function buildBarString($green = null, $red = null, $jsAutoUpdate = false)
{
	$barWidth = getBarWidth();
	$type = $barWidth ? 'px' : '%';
	if($green === null || $red === null) {
		$width = $barWidth ? ($barWidth.'px') : '100%';
		$returnString = '<div class="bar-na" style="width:'.$width.'">No Data Available</div>';
	}
	else {
		if(getBarWidth()) {
			$green = $green * getBarWidth() / 100;
			$red = getBarWidth() - $green;
			$type = 'px';
		}

		$returnString = '<div class="current-position-green" style="width:'.$green.$type.'"></div>'.
						'<div class="current-position-red" style="width: '.$red.$type.'"></div>';
	}
	
	if($jsAutoUpdate) {
		$returnString = jsAutoUpdateWrapper($returnString, $symbol, 'PositionLowHigh');
	}
	return $returnString;
}

function symbolPositionLowHigh($symbol = null, $jsAutoUpdate = false) {
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	list($low, $high) = explode(' - ', symbolInformation($symbol, Symbol::DaysRange));
	if('N/A' == $lastTrade || 'N/A' == $low || 'N/A' == $high) {
		return buildBarString();
	}
	$green = round(@(($lastTrade - $low)/($high-$low)) * 100);
	$green = min(100, max(0, $green));
	$red = 100 - $green;
	
	return buildBarString($green, $red, $jsAutoUpdate);
}

function symbolPositionPreviousCloseHigh($symbol = null, $jsAutoUpdate = false) {
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$previousClose = symbolInformation($symbol, Symbol::PreviousClose);
	$high = symbolDayHigh($symbol);
	if('N/A' == $lastTrade || 'N/A' == $previousClose || 'N/A' == $high) {
		return buildBarString();
	}
	$green = round(@(max(0,($lastTrade - $previousClose))/max(0,($high-$previousClose))) * 100);
	$green = min(100, max(0, $green));
	$red = 100 - $green;
	
	return buildBarString($green, $red, $jsAutoUpdate);
}

function symbolPositionOpenHigh($symbol = null, $jsAutoUpdate = false) {
	$lastTrade = symbolInformation($symbol, Symbol::LastTrade);
	$open = symbolInformation($symbol, Symbol::Open);
	$high = symbolDayHigh($symbol);
	if('N/A' == $lastTrade || 'N/A' == $open || 'N/A' == $high) {
		return buildBarString();
	}
	$green = round(@(max(0,($lastTrade - $open))/max(0,($high-$open))) * 100);
	$green = min(100, max(0, $green));
	$red = 100 - $green;
	
	return buildBarString($green, $red, $jsAutoUpdate);
}



function jsAutoUpdateWrapper($string, $symbol, $action) 
{
	return '<span class="autoUpdate" symbol="'.fs($symbol).'" action="'.$action.'">'.$string.'</span>';
}

function isUpDown($value = null, $returnString = null)
{
	if(!$returnString) {
		$returnString = $value;
	}
	if($value > 0) {
		return '<span class="change-up">'.$returnString.'</span>';
	}
	if($value < 0) {
		return '<span class="change-down">'.$returnString.'</span>';
	}
	return $returnString;
}

function symbolWeekRange52High($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::WeekRange52);
	if($jsAutoUpdate) {
		$returnString = '<span class="autoUpdate" symbol="'.fs($symbol).'" action="WeekRange52">'.$returnString.'</span>';
	}
	$returnStringArray=array();
	$returnStringArray=explode('-',$returnString);
	return $returnStringArray[1];
}

function symbolLastTradePer($symbol = null, $jsAutoUpdate = false) {
	$returnString = symbolInformation($symbol, Symbol::LastTrade);
	return $returnString; 
}
?>